]>
Commit | Line | Data |
---|---|---|
1f2bfbd0 SR |
1 | #!/bin/sh |
2 | # | |
3 | # link vmlinux | |
4 | # | |
5 | # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and | |
6 | # $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories | |
7 | # in the kernel tree, others are specified in arch/$(ARCH)/Makefile. | |
8 | # Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first. | |
9 | # | |
10 | # vmlinux | |
11 | # ^ | |
12 | # | | |
13 | # +-< $(KBUILD_VMLINUX_INIT) | |
14 | # | +--< init/version.o + more | |
15 | # | | |
16 | # +--< $(KBUILD_VMLINUX_MAIN) | |
17 | # | +--< drivers/built-in.o mm/built-in.o + more | |
18 | # | | |
19 | # +-< ${kallsymso} (see description in KALLSYMS section) | |
20 | # | |
21 | # vmlinux version (uname -v) cannot be updated during normal | |
22 | # descending-into-subdirs phase since we do not yet know if we need to | |
23 | # update vmlinux. | |
24 | # Therefore this step is delayed until just before final link of vmlinux. | |
25 | # | |
26 | # System.map is generated to document addresses of all kernel symbols | |
27 | ||
28 | # Error out on error | |
29 | set -e | |
30 | ||
31 | # Nice output in kbuild format | |
32 | # Will be supressed by "make -s" | |
33 | info() | |
34 | { | |
35 | if [ "${quiet}" != "silent_" ]; then | |
36 | printf " %-7s %s\n" ${1} ${2} | |
37 | fi | |
38 | } | |
39 | ||
40 | # Link of vmlinux.o used for section mismatch analysis | |
41 | # ${1} output file | |
42 | modpost_link() | |
43 | { | |
44 | ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \ | |
45 | --start-group ${KBUILD_VMLINUX_MAIN} --end-group | |
46 | } | |
47 | ||
48 | # Link of vmlinux | |
49 | # ${1} - optional extra .o files | |
50 | # ${2} - output file | |
51 | vmlinux_link() | |
52 | { | |
53 | local lds="${objtree}/${KBUILD_LDS}" | |
54 | ||
55 | if [ "${SRCARCH}" != "um" ]; then | |
56 | ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \ | |
57 | -T ${lds} ${KBUILD_VMLINUX_INIT} \ | |
58 | --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1} | |
59 | else | |
60 | ${CC} ${CFLAGS_vmlinux} -o ${2} \ | |
61 | -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \ | |
62 | -Wl,--start-group \ | |
63 | ${KBUILD_VMLINUX_MAIN} \ | |
64 | -Wl,--end-group \ | |
65 | -lutil ${1} | |
66 | rm -f linux | |
67 | fi | |
68 | } | |
69 | ||
70 | ||
71 | # Create ${2} .o file with all symbols from the ${1} object file | |
72 | kallsyms() | |
73 | { | |
74 | info KSYM ${2} | |
75 | local kallsymopt; | |
76 | ||
b92021b0 RR |
77 | if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then |
78 | kallsymopt="${kallsymopt} --symbol-prefix=_" | |
6895f97e JH |
79 | fi |
80 | ||
1f2bfbd0 | 81 | if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then |
6895f97e | 82 | kallsymopt="${kallsymopt} --all-symbols" |
1f2bfbd0 SR |
83 | fi |
84 | ||
7122c3e9 ML |
85 | if [ -n "${CONFIG_ARM}" ] && [ -n "${CONFIG_PAGE_OFFSET}" ]; then |
86 | kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET" | |
87 | fi | |
f6537f2f | 88 | |
00e6c28c SR |
89 | local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \ |
90 | ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}" | |
1f2bfbd0 SR |
91 | |
92 | ${NM} -n ${1} | \ | |
93 | scripts/kallsyms ${kallsymopt} | \ | |
94 | ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp - | |
95 | } | |
96 | ||
97 | # Create map file with all symbols from ${1} | |
98 | # See mksymap for additional details | |
99 | mksysmap() | |
100 | { | |
101 | ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2} | |
102 | } | |
103 | ||
1347a2ce LT |
104 | sortextable() |
105 | { | |
106 | ${objtree}/scripts/sortextable ${1} | |
107 | } | |
108 | ||
1f2bfbd0 SR |
109 | # Delete output files in case of error |
110 | trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR | |
111 | cleanup() | |
112 | { | |
113 | rm -f .old_version | |
114 | rm -f .tmp_System.map | |
115 | rm -f .tmp_kallsyms* | |
116 | rm -f .tmp_version | |
117 | rm -f .tmp_vmlinux* | |
118 | rm -f System.map | |
119 | rm -f vmlinux | |
120 | rm -f vmlinux.o | |
121 | } | |
122 | ||
123 | # | |
124 | # | |
125 | # Use "make V=1" to debug this script | |
126 | case "${KBUILD_VERBOSE}" in | |
127 | *1*) | |
128 | set -x | |
129 | ;; | |
130 | esac | |
131 | ||
132 | if [ "$1" = "clean" ]; then | |
133 | cleanup | |
134 | exit 0 | |
135 | fi | |
136 | ||
137 | # We need access to CONFIG_ symbols | |
423a8155 MM |
138 | case "${KCONFIG_CONFIG}" in |
139 | */*) | |
140 | . "${KCONFIG_CONFIG}" | |
141 | ;; | |
142 | *) | |
143 | # Force using a file from the current directory | |
144 | . "./${KCONFIG_CONFIG}" | |
145 | esac | |
1f2bfbd0 SR |
146 | |
147 | #link vmlinux.o | |
148 | info LD vmlinux.o | |
149 | modpost_link vmlinux.o | |
150 | ||
151 | # modpost vmlinux.o to check for section mismatches | |
152 | ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o | |
153 | ||
154 | # Update version | |
155 | info GEN .version | |
156 | if [ ! -r .version ]; then | |
157 | rm -f .version; | |
158 | echo 1 >.version; | |
159 | else | |
160 | mv .version .old_version; | |
161 | expr 0$(cat .old_version) + 1 >.version; | |
162 | fi; | |
163 | ||
164 | # final build of init/ | |
165 | ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init | |
166 | ||
167 | kallsymso="" | |
168 | kallsyms_vmlinux="" | |
169 | if [ -n "${CONFIG_KALLSYMS}" ]; then | |
170 | ||
171 | # kallsyms support | |
172 | # Generate section listing all symbols and add it into vmlinux | |
173 | # It's a three step process: | |
174 | # 1) Link .tmp_vmlinux1 so it has all symbols and sections, | |
175 | # but __kallsyms is empty. | |
176 | # Running kallsyms on that gives us .tmp_kallsyms1.o with | |
177 | # the right size | |
178 | # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of | |
179 | # the right size, but due to the added section, some | |
180 | # addresses have shifted. | |
181 | # From here, we generate a correct .tmp_kallsyms2.o | |
182 | # 2a) We may use an extra pass as this has been necessary to | |
183 | # woraround some alignment related bugs. | |
184 | # KALLSYMS_EXTRA_PASS=1 is used to trigger this. | |
185 | # 3) The correct ${kallsymso} is linked into the final vmlinux. | |
186 | # | |
187 | # a) Verify that the System.map from vmlinux matches the map from | |
188 | # ${kallsymso}. | |
189 | ||
190 | kallsymso=.tmp_kallsyms2.o | |
191 | kallsyms_vmlinux=.tmp_vmlinux2 | |
192 | ||
193 | # step 1 | |
194 | vmlinux_link "" .tmp_vmlinux1 | |
195 | kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o | |
196 | ||
197 | # step 2 | |
198 | vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2 | |
199 | kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o | |
200 | ||
201 | # step 2a | |
202 | if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then | |
203 | kallsymso=.tmp_kallsyms3.o | |
204 | kallsyms_vmlinux=.tmp_vmlinux3 | |
205 | ||
206 | vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3 | |
207 | ||
208 | kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o | |
209 | fi | |
210 | fi | |
211 | ||
212 | info LD vmlinux | |
213 | vmlinux_link "${kallsymso}" vmlinux | |
214 | ||
1347a2ce LT |
215 | if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then |
216 | info SORTEX vmlinux | |
217 | sortextable vmlinux | |
218 | fi | |
219 | ||
1f2bfbd0 SR |
220 | info SYSMAP System.map |
221 | mksysmap vmlinux System.map | |
222 | ||
223 | # step a (see comment above) | |
224 | if [ -n "${CONFIG_KALLSYMS}" ]; then | |
225 | mksysmap ${kallsyms_vmlinux} .tmp_System.map | |
226 | ||
227 | if ! cmp -s System.map .tmp_System.map; then | |
5369f550 | 228 | echo >&2 Inconsistent kallsyms data |
367e43c5 | 229 | echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround |
1f2bfbd0 SR |
230 | cleanup |
231 | exit 1 | |
232 | fi | |
233 | fi | |
234 | ||
235 | # We made a new kernel - delete old version file | |
236 | rm -f .old_version |